#include <stdio.h>


__global__ void printIdentity(float *A_diag_data,int *A_diag_i,int *A_diag_j,
                               float *A_offd_data,int *A_offd_i,int *A_offd_j,
                               float *u_data,float *f_data,float *Vext_data,float *tmp_data,int n)
{
   int tid =(blockIdx.x * blockDim.x) + threadIdx.x;
   float res;
   int jj,ii;
   int ns,ne;
   int i;

   int size = n/8;
   int rest = n - size*8;
   //a_d[tid] = tid;

          if (tid < rest)
            {
               ns = tid*size+tid;
               ne = (tid+1)*size+tid+1;
            }
            else
            {
               ns = tid*size+rest;
               ne = (tid+1)*size+rest;
            }



          for (i = ns; i < ne; i++)   /* interior points first */
            {
               /*-----------------------------------------------------------
                * If diagonal is nonzero, relax point i; otherwise, skip it.
                *-----------------------------------------------------------*/

               if ( A_diag_data[A_diag_i[i]] != 0.0)
               {
                  res = f_data[i];
                  for (jj = A_diag_i[i]+1; jj < A_diag_i[i+1]; jj++)
                  {
                     ii = A_diag_j[jj];
                       if (ii >= ns && ii < ne)
                       {
                          res -= A_diag_data[jj] * u_data[ii];
                        }
                       else
                          res -= A_diag_data[jj] * tmp_data[ii];
     
                  }
                  for (jj = A_offd_i[i]; jj < A_offd_i[i+1]; jj++)
                  {
                     ii = A_offd_j[jj];
                     res -= A_offd_data[jj] * Vext_data[ii];
                  }
                  u_data[i] = res / A_diag_data[A_diag_i[i]];
               }
            }

             
             for (i = ne-1; i > ns-1; i--)       /* interior points first */
            {

               /*-----------------------------------------------------------
                * If diagonal is nonzero, relax point i; otherwise, skip it.
                *-----------------------------------------------------------*/

               if ( A_diag_data[A_diag_i[i]] != 0.0)
               {
                  res = f_data[i];
                  for (jj = A_diag_i[i]+1; jj < A_diag_i[i+1]; jj++)
                  {
                     ii = A_diag_j[jj];
                     if (ii >= ns && ii < ne)
                     {
                        res -= A_diag_data[jj] * u_data[ii];
                     }
                     else
                        res -= A_diag_data[jj] * tmp_data[ii];
                  }
                  for (jj = A_offd_i[i]; jj < A_offd_i[i+1]; jj++)
                  {
                     ii = A_offd_j[jj];
                     res -= A_offd_data[jj] * Vext_data[ii];
                  }
                  u_data[i] = res / A_diag_data[A_diag_i[i]];
               }
            }
 

}
